require "dollarr/version"

module Dollarr
	def self.included(base)
    base.class_eval do
      if defined?(ActiveRecord) && self.ancestors.include?(ActiveRecord::Base)
        attr_names = column_names
      elsif defined?(Mongoid) && self.included_modules.include?(Mongoid::Document)
        attr_names = fields.keys
      end
      attr_names.grep(/in_cents/).each do |cents_column|
      	dollar_method = cents_column.gsub(/_in_cents/, '')

      	define_method(dollar_method) do
      		send("#{cents_column}").to_f / 100.0
      	end

      	define_method(dollar_method + "=") do |amount_in_dollar|
      		send("#{cents_column}=", amount_in_dollar.to_f * 100)
      	end
      end
    end
  end
end
